// EE231002 Lab10. Word Processing
// 108061112, 林靖
// Nov. 30, 2019

#include <stdio.h>					// Standard input and output library
#include <string.h>					// Declared strlen()

#define PN 1000						// Max num of char for a paragraph
#define PW 80						// Page width for the three title lines
#define LN 52						// Num of lines for output buffer
#define CW 38						// Column width

int main(void)						// Called at program startup
{
	int i, j;						// Indices for looping
	char para[PN + 1];				// Input paragraph read in as single string
	char outBuffer[LN + 1][CW + 1];	// For breaking the paragraph into lines
	char *copied;					// Pos of char been copied into outBuffer
	int line;						// Num of lines the paragraph broken into

	for (i = 0; i < 3; i++) {		// There are three title lines
		for (j = 0; j < PW && (para[j] = getchar()) != '\n'; j++) ;	// Read in
		while (j <= PW)
			para[j++] = '\0';		// Fill all the rest with NULL
		for (j = (PW - strlen(para)) / 2; j > 0; j--)
			putchar(' ');			// Make title be printed at the center
		puts(para);					// Print title out
	}
	while ((para[0] = getchar()) != EOF) {	// Test against EOF to stop program
		if (para[0] == '\n') {		// If this line in the file has no content
			putchar('\n');			// Print new line
		} else {					// Else, read the paragraph into para
			for (i = 1; i <= PN && (para[i] = getchar()) != '\n'; i++) ; // Read
			while (++i <= PN)
				para[i] = '\0';		// Fill all the rest with NULL
			copied = para;			// Re-point
			for (line = 0; line < LN && *copied != '\0'    // To break para
									 && *copied != '\n'; line++) {
				for (i = 0; i <= CW && copied + i <= para + PN; i++)
					outBuffer[line][i] = *(copied + i);  // Copy part of para
				for ( ; i >= 0 && outBuffer[line][i] != ' ' // Find last space
							   && outBuffer[line][i] != '\n'; i--) ;
				outBuffer[line][i] = '\0';   // Replace the space with NULL
				copied += ++i;				 // Update pos of copied char
			}
			outBuffer[line][0] = '\0';		 // Mark the ending of paragraph
			line = (line + 1) / 2;			 // For printing two-column format
			for (i = 0; i < line; i++) {	 // To print each line out
				for (j = CW - strlen(outBuffer[i]); j > 0; j--)
					putchar(' ');			 // Make left column right-aligned
				printf(outBuffer[i]);		 // Print left column out
				printf(" | ");				 // Print vertical line between
				puts(outBuffer[i + line]);	 // Print right column out
			}
		}
	}
	return 0;								 // Normal program termination
}
